Bug 751172

Summary: Review Request: cumin - management console for Red Hat MRG grid
Product: [Fedora] Fedora Reporter: Trevor McKay <tmckay>
Component: Package ReviewAssignee: Nuno Santos <nsantos>
Status: CLOSED NEXTRELEASE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: aortega, herrold, matt, notting, nsantos, package-review
Target Milestone: ---Flags: nsantos: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-01-18 10:54:56 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 751344    
Bug Blocks:    

Description Trevor McKay 2011-11-03 14:30:56 EDT
Spec URL: sftp://fedorapeople.org/home/fedora/tmckay/cumin.spec
SRPM URL: sftp://fedorapeople.org/home/fedora/tmckay/cumin-0.1.5105-1.fc15.src.rpm
Description:

Cumin is a web UI for use with MRG Grid and Messaging.  It already ships in el5 and el6 as a part of the Red Hat MRG offerings.  We would like to get it into fedora along with the other MRG components for greater exposure.
Comment 1 Trevor McKay 2011-11-03 14:38:49 EDT
Adding depends on for 702143.  Cumin has a dependency on python-wallaby, also on review for inclusion into Fedora.
Comment 2 Trevor McKay 2011-11-04 09:13:33 EDT
Adding depends on for 751344.  Cumin will install and operate without Sesame but data under the Inventory tab will be missing.  Sesame really should be running on all nodes in a condor pool for Cumin to be complete.
Comment 3 Trevor McKay 2011-11-07 12:31:55 EST
Modifying cumin to use systemd scripts instead of sysvinit, on feedback from spot.
Comment 4 Trevor McKay 2011-11-11 15:19:03 EST
Spec URL: http://tmckay.fedorapeople.org/cumin.spec
SRPM URL: http://tmckay.fedorapeople.org/cumin-0.1.5137-1.fc15.src.rpm

Updated to use systemd.
Comment 5 Nuno Santos 2011-12-13 17:15:39 EST
Here's my review of cumin, using the package review guidelines template:

====================
NO - MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
$ rpmlint /var/lib/mock/fedora-rawhide-i386/result/cumin-0.1.5137-1.fc17.*.rpm
cumin.noarch: E: explicit-lib-dependency liberation-sans-fonts
cumin.noarch: W: non-standard-uid /etc/cumin/cumin.conf cumin
cumin.noarch: W: non-standard-gid /etc/cumin/cumin.conf cumin
cumin.noarch: E: non-readable /etc/cumin/cumin.conf 0600L
cumin.noarch: W: non-standard-uid /var/log/cumin cumin
cumin.noarch: W: non-standard-gid /var/log/cumin cumin
cumin.noarch: W: log-files-without-logrotate /var/log/cumin
cumin.noarch: W: no-manual-page-for-binary cumin-database
cumin.noarch: W: no-manual-page-for-binary cumin-admin
cumin.noarch: W: no-manual-page-for-binary cumin-bench
cumin.noarch: W: no-manual-page-for-binary cumin-test
cumin.noarch: W: no-manual-page-for-binary cumin-data
cumin.noarch: W: no-manual-page-for-binary cumin
cumin.noarch: W: no-manual-page-for-binary cumin-command-test
cumin.noarch: W: no-manual-page-for-binary cumin-smoke-test
cumin.noarch: W: no-manual-page-for-binary cumin-web-test
cumin.noarch: W: no-manual-page-for-binary cumin-admin-test
cumin.noarch: W: no-manual-page-for-binary cumin-web
cumin.noarch: W: no-manual-page-for-binary cumin-data-test
cumin.noarch: W: dangerous-command-in-%post ln
cumin.src:56: W: macro-in-comment %{buildroot}
cumin.src:56: W: macro-in-comment %{cumin_home}
cumin.src:56: W: macro-in-comment %{buildroot}
cumin.src:56: W: macro-in-comment %{cumin_etc}
cumin.src:58: W: macro-in-comment %{buildroot}
cumin.src:58: W: macro-in-comment %{cumin_home}
cumin.src:58: W: macro-in-comment %{buildroot}
cumin.src:58: W: macro-in-comment %{_sysconfdir}
cumin.src: W: no-%build-section
cumin.src:22: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 22)
2 packages and 0 specfiles checked; 2 errors, 28 warnings.

The first error (explicit-lib-dependency liberation-sans-fonts) looks like an rpmlint parsing glitch (found "lib" in "liberation" and assumed it was a lib), but the permissions error is valid. Also, please fix the last 2 warnings (the others are related to the use of a special cumin:cumin user and look benign).

OK - MUST: The package must be named according to the Package Naming Guidelines.

OK - MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.

OK - MUST: The package must meet the Packaging Guidelines.

OK (GPLv2+) - MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.

OK - MUST: The License field in the package spec file must match the actual license.

NO (see notes) - MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
  NOTES: the tarfile includes the LICENSE but it is not being packaged. That file, along with the COPYING and README files should be added to a %doc section.

OK - MUST: The spec file must be written in American English.

OK - MUST: The spec file for the package MUST be legible.

OK - MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

$ rpm2cpio cumin-0.1.5137-1.fc15.src.rpm | cpio -ivd ; md5sum cumin-0.1.5137.tar.gz
cumin-0.1.5137.tar.gz
cumin.spec
3416 blocks
939b1b932fbc726eca8a1afa7f1d4f4f  cumin-0.1.5137.tar.gz

$ wget http://fedorahosted.org/releases/c/u/cumin/cumin-0.1.5137.tar.gz ; md5sum cumin-0.1.5137.tar.gz
--2011-12-13 17:03:19--  http://fedorahosted.org/releases/c/u/cumin/cumin-0.1.5137.tar.gz
Resolving fedorahosted.org... 66.135.52.17
Connecting to fedorahosted.org|66.135.52.17|:80... connected.
HTTP request sent, awaiting response... 301 Moved Permanently
Location: https://fedorahosted.org/releases/c/u/cumin/cumin-0.1.5137.tar.gz [following]
--2011-12-13 17:03:19--  https://fedorahosted.org/releases/c/u/cumin/cumin-0.1.5137.tar.gz
Connecting to fedorahosted.org|66.135.52.17|:443... connected.
HTTP request sent, awaiting response... 200 OK
Length: 1729243 (1.6M) [application/x-gzip]
Saving to: “cumin-0.1.5137.tar.gz”

100%[==========================================================>] 1,729,243   1.62M/s   in 1.0s    

2011-12-13 17:03:21 (1.62 MB/s) - “cumin-0.1.5137.tar.gz” saved [1729243/1729243]

939b1b932fbc726eca8a1afa7f1d4f4f  cumin-0.1.5137.tar.gz


OK - MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.

$ mock -r fedora-rawhide-i386 cumin-0.1.5137-1.fc15.src.rpm 
INFO: mock.py version 1.1.18 starting...
State Changed: init plugins
INFO: selinux enabled
State Changed: start
INFO: Start(cumin-0.1.5137-1.fc15.src.rpm)  Config(fedora-rawhide-i386)
State Changed: lock buildroot
State Changed: clean
INFO: chroot (/var/lib/mock/fedora-rawhide-i386) unlocked and deleted
State Changed: unlock buildroot
State Changed: init
State Changed: lock buildroot
Mock Version: 1.1.18
INFO: Mock Version: 1.1.18
INFO: calling preinit hooks
INFO: enabled root cache
State Changed: unpacking root cache
INFO: enabled yum cache
State Changed: cleaning yum metadata
INFO: enabled ccache
State Changed: running yum
State Changed: unlock buildroot
INFO: Installed packages:
State Changed: setup
State Changed: build
INFO: Done(cumin-0.1.5137-1.fc15.src.rpm) Config(fedora-rawhide-i386) 1 minutes 56 seconds
INFO: Results and/or logs in: /var/lib/mock/fedora-rawhide-i386/result
State Changed: end

NA - MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.

OK - MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

NA - MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

NA - MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.

OK - MUST: Packages must NOT bundle copies of system libraries.

NA - MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.

OK - MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

OK - MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)

NO (see rpmlint notes) - MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.

OK - MUST: Each package must consistently use macros.

OK - MUST: The package must contain code, or permissable content.

NA - MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).

NA - MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.

NA - MUST: Header files must be in a -devel package.

NA - MUST: Static libraries must be in a -static package.

NA - MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.

NA - MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}

NA - MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.

NA - MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.

OK - MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.

OK - MUST: All filenames in rpm packages must be valid UTF-8.


OK (but see rpmlint notes) - SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.

NA - SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.

OK (mock output above) - SHOULD: The reviewer should test that the package builds in mock.

OK - SHOULD: The package should compile and build into binary rpms on all supported architectures.

OK - SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
  NOTES: cumin has received extensive testing as part of RHEL/MRG

OK - SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.

NA - SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.

NA - SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.

NA - SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

** - SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

====================


Please resolve the file permissions issue, and package the LICENSE, README, COPYING files as %doc. Other than that it looks good.
Comment 6 Trevor McKay 2011-12-14 11:22:15 EST
"The first error (explicit-lib-dependency liberation-sans-fonts) looks like an
rpmlint parsing glitch (found "lib" in "liberation" and assumed it was a lib),
but the permissions error is valid."

cumin.noarch: E: non-readable /etc/cumin/cumin.conf 0600L

The issue here is that the cumin.conf file contains credentials for authentication to the broker which must be protected from the general user.  Hence, the file is owned by the "cumin" user and permissions restricted to 0600.

Is it possible to get an exception here?
Comment 7 Trevor McKay 2011-12-15 12:20:07 EST
Spec URL: http://tmckay.fedorapeople.org/cumin.spec
SRPM URL: http://tmckay.fedorapeople.org/cumin-0.1.5137-2.fc16.src.rpm

Updated.  

Added empty build section, 
fixed mixed tabs and spaces, 
added %doc for %{cumin_doc}/*, 
removed default enable of service in %post
Comment 8 Nuno Santos 2011-12-20 13:45:27 EST
Thanks for the explanation on the file permissions, makes sense, and for fixing the remaining issues with the specfile.

I've rebuilt the updated srpm in mock:

$ mock -r fedora-rawhide-i386 cumin-0.1.5137-2.fc16.src.rpm 
INFO: mock.py version 1.1.18 starting...
State Changed: init plugins
INFO: selinux enabled
State Changed: start
INFO: Start(cumin-0.1.5137-2.fc16.src.rpm)  Config(fedora-rawhide-i386)
State Changed: lock buildroot
State Changed: clean
INFO: chroot (/var/lib/mock/fedora-rawhide-i386) unlocked and deleted
State Changed: unlock buildroot
State Changed: init
State Changed: lock buildroot
Mock Version: 1.1.18
INFO: Mock Version: 1.1.18
INFO: calling preinit hooks
INFO: enabled root cache
State Changed: unpacking root cache
INFO: enabled yum cache
State Changed: cleaning yum metadata
INFO: enabled ccache
State Changed: running yum
State Changed: unlock buildroot
INFO: Installed packages:
State Changed: setup
State Changed: build
INFO: Done(cumin-0.1.5137-2.fc16.src.rpm) Config(fedora-rawhide-i386) 2 minutes 32 seconds
INFO: Results and/or logs in: /var/lib/mock/fedora-rawhide-i386/result
State Changed: end

$ rpmlint /var/lib/mock/fedora-rawhide-i386/result/cumin-0.1.5137-2.*.rpm
cumin.noarch: E: explicit-lib-dependency liberation-sans-fonts
cumin.noarch: W: non-standard-uid /etc/cumin/cumin.conf cumin
cumin.noarch: W: non-standard-gid /etc/cumin/cumin.conf cumin
cumin.noarch: E: non-readable /etc/cumin/cumin.conf 0600L
cumin.noarch: W: non-standard-uid /var/log/cumin cumin
cumin.noarch: W: non-standard-gid /var/log/cumin cumin
cumin.noarch: W: log-files-without-logrotate /var/log/cumin
cumin.noarch: W: no-manual-page-for-binary cumin-database
cumin.noarch: W: no-manual-page-for-binary cumin-admin
cumin.noarch: W: no-manual-page-for-binary cumin-bench
cumin.noarch: W: no-manual-page-for-binary cumin-test
cumin.noarch: W: no-manual-page-for-binary cumin-data
cumin.noarch: W: no-manual-page-for-binary cumin
cumin.noarch: W: no-manual-page-for-binary cumin-command-test
cumin.noarch: W: no-manual-page-for-binary cumin-smoke-test
cumin.noarch: W: no-manual-page-for-binary cumin-web-test
cumin.noarch: W: no-manual-page-for-binary cumin-admin-test
cumin.noarch: W: no-manual-page-for-binary cumin-web
cumin.noarch: W: no-manual-page-for-binary cumin-data-test
cumin.noarch: W: dangerous-command-in-%post ln
cumin.src:58: W: macro-in-comment %{buildroot}
cumin.src:58: W: macro-in-comment %{cumin_home}
cumin.src:58: W: macro-in-comment %{buildroot}
cumin.src:58: W: macro-in-comment %{cumin_etc}
cumin.src:60: W: macro-in-comment %{buildroot}
cumin.src:60: W: macro-in-comment %{cumin_home}
cumin.src:60: W: macro-in-comment %{buildroot}
cumin.src:60: W: macro-in-comment %{_sysconfdir}
2 packages and 0 specfiles checked; 2 errors, 26 warnings.

(same warnings/errors as before; errors have been explained)

Looks good, package is APPROVED.
Comment 9 Trevor McKay 2011-12-21 11:14:40 EST
New Package SCM Request
=======================
Package Name: cumin
Short Description: Red Hat MRG grid management web console
Owners: tmckay matt
Branches: f15 f16 f17
InitialCC: tmckay croberts
Comment 10 Jon Ciesla 2011-12-21 11:18:55 EST
Git done (by process-git-requests).

f17==devel.